#! /usr/bin/env node
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

require("@babel/polyfill");

var _commander = _interopRequireDefault(require("commander"));

var _utility = require("./utility");

var _path = require("path");

var _Package = _interopRequireDefault(require("./Package"));

var _nodeToolkit = require("@tech_query/node-toolkit");

var _fsExtra = require("fs-extra");

_commander.default.name(_utility.meta.name).version(_utility.meta.version).description(_utility.meta.description).usage('[options] <entry file> [bundle file]').arguments('<entry file> [bundle file]').option('-a, --include-all', 'Bundle all dependencies (include those in "./node_modules/")').option('-m, --minify', 'Generate minified source code & source map').option('-s, --std-out', 'Write into "stdout" without logs').parse(process.argv);

const entry_file = _commander.default.args[0];
if (!entry_file) _commander.default.outputHelp(), process.exit(1);
const bundle_file = _commander.default.args[1] || (0, _path.join)(entry_file, '../../', (0, _path.basename)(entry_file)),
      pack = new _Package.default(entry_file, _commander.default.includeAll, null, _commander.default.stdOut);
if (!_commander.default.stdOut) console.time('Package bundle');
var bundle = pack.bundle((0, _path.basename)(bundle_file));

if (_commander.default.minify) {
  const _uglify = (0, _nodeToolkit.uglify)(bundle, `${(0, _path.basename)(bundle_file)}.js`),
        code = _uglify.code,
        map = _uglify.map;

  (0, _fsExtra.outputFileSync)(`${bundle_file}.min.js`, code);
  (0, _fsExtra.outputFileSync)(`${bundle_file}.js.map`, map);
}

if (pack.entry.CLI) bundle = `${pack.entry.CLI}\n\n${bundle}`;
if (_commander.default.stdOut) process.stdout.write(bundle), process.exit();
(0, _fsExtra.outputFileSync)(`${bundle_file}.js`, bundle);
console.info('-'.repeat(30));
console.timeEnd('Package bundle');
console.info(`Module count: ${pack.length}`);
//# sourceMappingURL=index.js.map